Poj 2151 Check the difficulty of problems【概率dp+活用补集】

来源:互联网 发布:压缩文件解压软件 编辑:程序博客网 时间:2024/05/22 07:50

Check the difficulty of problems
Time Limit: 2000MS Memory Limit: 65536KTotal Submissions: 7466 Accepted: 3204

Description

Organizing a programming contest is not an easy job. To avoid making the problems too difficult, the organizer usually expect the contest result satisfy the following two terms: 
1. All of the teams solve at least one problem. 
2. The champion (One of those teams that solve the most problems) solves at least a certain number of problems. 

Now the organizer has studied out the contest problems, and through the result of preliminary contest, the organizer can estimate the probability that a certain team can successfully solve a certain problem. 

Given the number of contest problems M, the number of teams T, and the number of problems N that the organizer expect the champion solve at least. We also assume that team i solves problem j with the probability Pij (1 <= i <= T, 1<= j <= M). Well, can you calculate the probability that all of the teams solve at least one problem, and at the same time the champion team solves at least N problems? 

Input

The input consists of several test cases. The first line of each test case contains three integers M (0 < M <= 30), T (1 < T <= 1000) and N (0 < N <= M). Each of the following T lines contains M floating-point numbers in the range of [0,1]. In these T lines, the j-th number in the i-th line is just Pij. A test case of M = T = N = 0 indicates the end of input, and should not be processed.

Output

For each test case, please output the answer in a separate line. The result should be rounded to three digits after the decimal point.

Sample Input

2 2 20.9 0.91 0.90 0 0

Sample Output

0.972

Source

POJ Monthly,鲁小石

题目大意:

给你M道题,T个队伍,问你每个队伍至少作对一题,并且冠军队伍要至少作对N题的概率。


思路:


1、设定P1=每个队都至少做对一题的概率、设定p2=每个队都只能做对1~N-1道题的概率。那么显然ans=p1-p2;


2、那么我们设定dp【i】【j】【k】表示第i个队伍,做到第j题,做对了k道题的概率。

那么很容易得到状态转移方程:dp【i】【j】【k】=dp【i】【j-1】【k】*(1-a【i】【j】)+dp【i】【j-1】【k-1】*a【i】【j】

那么我们再设定另外一个数组R【i】【j】表示第i个队,做对了j道题的概率,那么有R【i】【j】=dp【i】【T】【j】;

很显然,p1=π(1-R【i】【0】)【1<=i<=T】;

此时我们可以对R【i】【j】维护一个前缀和,表示第i个队,做对1~j道题的概率,那么p2=π(R【i】【n-1】)【1<=i<=T】;

ans=p1-p2;

注意,当N为1的时候,p2=0;


Ac代码:

#include<stdio.h>#include<string.h>using namespace std;double dp[1052][65][65];double R[1050][65];double a[1050][65];int main(){    int n,t,maxn;    while(~scanf("%d%d%d",&n,&t,&maxn))    {        if(n==0&&t==0&&maxn==0)break;        for(int i=1;i<=t;i++)        {            for(int j=1;j<=n;j++)            {                scanf("%lf",&a[i][j]);            }        }        memset(R,0,sizeof(R));        memset(dp,0,sizeof(dp));        for(int i=1;i<=t;i++)dp[i][0][0]=1;        for(int i=1;i<=t;i++)        {            for(int j=1;j<=n;j++)            {                for(int k=0;k<=j;k++)                {                    if(k==0)                    {                        dp[i][j][k]=dp[i][j-1][0]*(1-a[i][j]);                    }                    else                    dp[i][j][k]=dp[i][j-1][k-1]*a[i][j]+dp[i][j-1][k]*(1-a[i][j]);                }            }            for(int j=0;j<=n;j++)            R[i][j]=dp[i][n][j];        }        for(int i=1;i<=t;i++)        {            for(int j=2;j<=n;j++)            {                R[i][j]=R[i][j]+R[i][j-1];            }        }        double p1=1;        for(int i=1;i<=t;i++)p1*=(1-R[i][0]);        double p2=1;        for(int i=1;i<=t;i++)p2*=R[i][maxn-1];        if(maxn==1)p2=0;        printf("%.3f\n",p1-p2);    }    return 0;}






0 0
原创粉丝点击